if grep -q QEMU /proc/cpuinfo || dmesg | grep -q 'Manufacturer: QEMU' ; then \
	export WITHOUT_SWAP=yes ;\
fi ;\
sleep 2 ;\
list-devices disk | tr '\n' ' ' > /tmp/list-devices; \
read DISKA DISKB < /tmp/list-devices ;\
SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
MBR_LIMIT=2000000000000 ;\
if [ -b "${DISKB}" ]; then \
	SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
	SIZE2=$(fdisk -l "${DISKB}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
	if [ -n ${SIZE1} ] && [ -n ${SIZE2} ] && [ "${SIZE1}" = "${SIZE2}" ]; then \
		USE_MIRROR=yes; \
	else \
		USE_MIRROR=no; \
	fi; \
fi; \
debconf-set partman-basicfilesystems/choose_label gpt ;\
debconf-set partman-basicfilesystems/default_label gpt ;\
debconf-set partman-partitioning/choose_label gpt ;\
debconf-set partman-partitioning/default_label gpt ;\
debconf-set partman/choose_label gpt ;\
debconf-set partman/default_label gpt ;\
if [ -d /sys/firmware/efi ]; then \
	debconf-set partman-efi/non_efi_system true ;\
fi ;\
if [ "#${USE_MIRROR}" = "#yes" ]; then \
	debconf-set mdadm/boot_degraded true ;\
	debconf-set partman-auto/disk "${DISKA} ${DISKB}";\
	debconf-set partman-auto/method "raid";\
	debconf-set partman-md/device_remove_md true ;\
	if [ -d /sys/firmware/efi ]; then \
		debconf-set partman-auto/expert_recipe "multiraid :: \
			300 200 500 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
			128 512 100% raid $gptonly{ } $primary method{ raid }	. \
			1024 10000 1000000000 raid $gptonly{ } $primary method{ raid }	. ";\
	else \
		debconf-set partman-auto/expert_recipe "multiraid :: \
			1 1 1 free	$gptonly{ } $primary{ } $bios_boot{ } method{ biosgrub } . \
			128 512 100% raid $gptonly{ } $primary method{ raid }	. \
			1024 10000 1000000000 raid $gptonly{ } $primary method{ raid }	. ";\
	fi ;\
	debconf-set partman-auto-raid/recipe " \
		1 2 0 swap - ${DISKA}2#${DISKB}2 . \
		1 2 0 ext4 / ${DISKA}3#${DISKB}3 . ";\
	debconf-set grub-installer/bootdev "${DISKA} ${DISKB}";\
else \
	debconf-set partman-auto/disk "${DISKA}";\
	debconf-set partman-auto/method "regular";\
	if [ -n "${WITHOUT_SWAP}" ]; then \
		debconf-set partman-auto/expert_recipe "boot-root :: \
			1 1 1 free $gptonly{ } $primary{ } $bios_boot{ } method{ biosgrub } . \
			1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
	else \
		if [ -d /sys/firmware/efi ]; then \
			debconf-set partman-auto/expert_recipe "boot-root :: \
			300 200 500 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
			128 512 100% linux-swap method{ swap } format{ } . \
			1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
		else \
			debconf-set partman-auto/expert_recipe "boot-root :: \
			1 1 1 free $gptonly{ } $primary{ } $bios_boot{ } method{ biosgrub } . \
			128 512 100% linux-swap method{ swap } format{ } . \
			1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
		fi ;\
	fi ;\
	debconf-set grub-installer/bootdev "${DISKA}";\
fi

